name: hdav listeners

# CICD only is activated when:
# - there is a push to a PR from any branch to any branch
# - the protected branches are updated
on:
  push:
    branches:
      - main
      - develop
    tags:
      - '*'
    paths:
      - 'components/hdav-listeners/**'
      - 'components/hdar-sdk/**'
      - '.github/workflows/hdav-listeners.yaml'
  pull_request:
    paths:
      - 'components/hdav-listeners/**'
      - 'components/hdar-sdk/**'
      - '.github/workflows/hdav-listeners.yaml'

env: # Cannot be directly used to populate the workflow inputs and secrets..
  # Needed for base images of hdav
  SNS_REGISTRY_COMMON: registry.atosresearch.eu:18467
  # Needed for the dockerfile base image
  TMT_REGISTRY_COMMON: registry.atosresearch.eu:18488
  # Target repo in Nexus registry
  NEPHELE_REGISTRY_COMMON: registry.atosresearch.eu:18498
  IMAGE_NAME: hdavlisteners

# The workflow has a concurrency check
jobs:
  use-kaniko-build:
    uses: GLB-BDS-ETSN-COMMON/.github-private/.github/workflows/kaniko-build-test-and-push.yaml@main
    with:
      name: hdavlisteners
      target-registry: registry.atosresearch.eu:18498
      image-name: hdavlisteners
      context: ""
      dockerfile-path: components/hdav-listeners/install/dockerfile
    secrets:
      kaniko-login: |
          {
            "auths": {
              "https://registry.atosresearch.eu:18467": {
                "auth": "$(echo -n "${{ secrets.NEXUS_USER }}:${{ secrets.NEXUS_PAT }}" | base64 -w0)"
              },
              "https://registry.atosresearch.eu:18488": {
                "auth": "$(echo -n "${{ secrets.NEXUS_USER }}:${{ secrets.NEXUS_PAT }}" | base64 -w0)"
              },
              "https://registry.atosresearch.eu:18498": {
                "auth": "$(echo -n "${{ secrets.NEXUS_USER }}:${{ secrets.NEXUS_PAT }}" | base64 -w0)"
              },
              "https://registry.atosresearch.eu:18520": {
                "auth": "$(echo -n "${{ secrets.NEXUS_USER }}:${{ secrets.NEXUS_PAT }}" | base64 -w0)"
              }
            }
          }
      gh-pat: ${{ secrets.GH_PAT }}
      extra-args: |
        --push-retry 2
  use-go-test-coverage:
    needs: [use-kaniko-build]
    uses: GLB-BDS-ETSN-COMMON/.github-private/.github/workflows/go-test-coverage.yaml@main
    with:
      name: hdavlisteners
      target-registry: registry.atosresearch.eu:18498
      image-name: hdavlisteners
      image-tag: ${{ needs.use-kaniko-build.outputs.tag }}
    secrets:
      target-registry-user: ${{ secrets.NEXUS_USER }}
      target-registry-password: ${{ secrets.NEXUS_PAT }}
  use-documentation:
    needs: [use-kaniko-build,use-go-test-coverage]
    uses: GLB-BDS-ETSN-COMMON/.github-private/.github/workflows/documentation.yaml@main
    with:
      name: hdavlisteners
      image-name: hdavlisteners
      image-tag: ${{ needs.use-kaniko-build.outputs.tag }}
      coverage: ${{ needs.use-go-test-coverage.outputs.coverage }}
    secrets:
      gh-pat: ${{ secrets.GH_PAT }}
      gh-user: ${{ secrets.GH_USER }}
      gh-email: ${{ secrets.GH_EMAIL }}
